/*
dttools is Copyright (C) 2002 Douglas Thain
This software is released under the GNU General Public License.
See the file COPYING for details.
*/

#ifndef SPARSE_FILE_H
#define SPARSE_FILE_H

#include "int_sizes.h"

typedef UINT64_T sparse_file_length_t;
#define SPARSE_FILE_LENGTH_FORMAT UINT64_FORMAT

struct sparse_file * sparse_file_open( const char *path );
struct sparse_file * sparse_file_create( const char *path );
void sparse_file_close( struct sparse_file *h );
void sparse_file_delete( const char *path );
char * sparse_file_name( struct sparse_file *s );

int  sparse_file_read( struct sparse_file *h, void *data, sparse_file_length_t length, sparse_file_length_t offset, sparse_file_length_t *actual );
int  sparse_file_write( struct sparse_file *h, const void *data, sparse_file_length_t length, sparse_file_length_t offset );
int  sparse_file_commit( struct sparse_file *h );

int  sparse_file_set_size( struct sparse_file *h, sparse_file_length_t size );
int  sparse_file_get_size( struct sparse_file *h, sparse_file_length_t *size );
void sparse_file_get_nbytes( struct sparse_file *h, sparse_file_length_t *nbytes );

int sparse_file_set_attr( struct sparse_file *h, const char *name, const char *fmt, ... );
int sparse_file_get_attr( struct sparse_file *h, const char *name, const char *fmt, ... );

#endif
